void ChartsGraph_Draw( ChartsGraph _this, GraphicsCanvas aCanvas, XRect aClip, XPoint 
  aOffset, XInt32 aOpacity, XBool aBlend )
{
  XFloat p1X = 0.000000f;
  XFloat p1Y = 0.000000f;
  XFloat p2X = 0.000000f;
  XFloat p2Y = 0.000000f;
  XInt32 dx = _this->Super2.Bounds.Point1.X + aOffset.X;
  XInt32 dy = _this->Super2.Bounds.Point1.Y + aOffset.Y;
  XColor dotCol = _this->DotColor;
  XColor linCol = _this->LineColor;
  XColor hrzCol = _this->HorzGridColor;
  XColor vrtCol = _this->VertGridColor;
  XFloat lw = _this->LineWidth / 2.000000f;
  XFloat dw = _this->DotWidth / 2.000000f;
  XInt32 opacity = ((( aOpacity + 1 ) * _this->Super1.Opacity ) >> 8 ) + 1;
  ChartsCoord coord;

  aBlend = (XBool)( aBlend && (( _this->Super3.viewState & CoreViewStateAlphaBlended 
  ) == CoreViewStateAlphaBlended ));

  if ( opacity < 256 )
  {
    dotCol.Alpha = (XUInt8)(( dotCol.Alpha * opacity ) >> 8 );
    linCol.Alpha = (XUInt8)(( linCol.Alpha * opacity ) >> 8 );
    hrzCol.Alpha = (XUInt8)(( hrzCol.Alpha * opacity ) >> 8 );
    vrtCol.Alpha = (XUInt8)(( vrtCol.Alpha * opacity ) >> 8 );
  }

  CoreGroup_Draw((CoreGroup)_this, aCanvas, aClip, aOffset, aOpacity, aBlend );

  if ( _this->HorzGridColor.Alpha > 0 )
  {
    XInt32 y;

    for ( y = _this->CoordOrigin.Y + dy; y >= dy; y = y - _this->GridDistance.Y )
      GraphicsCanvas_DrawLine( aCanvas, aClip, EwNewPoint( dx, y ), EwNewPoint( 
      dx + EwGetRectW( _this->Super2.Bounds ), y ), hrzCol, hrzCol, aBlend );

    for ( y = ( _this->CoordOrigin.Y + dy ) + _this->GridDistance.Y; y < ( dy + 
         EwGetRectH( _this->Super2.Bounds )); y = y + _this->GridDistance.Y )
      GraphicsCanvas_DrawLine( aCanvas, aClip, EwNewPoint( dx, y ), EwNewPoint( 
      dx + EwGetRectW( _this->Super2.Bounds ), y ), hrzCol, hrzCol, aBlend );
  }

  if ( _this->VertGridColor.Alpha > 0 )
  {
    XInt32 x;

    for ( x = _this->CoordOrigin.X + dx; x >= dx; x = x - _this->GridDistance.X )
      GraphicsCanvas_DrawLine( aCanvas, aClip, EwNewPoint( x, dy ), EwNewPoint( 
      x, dy + EwGetRectH( _this->Super2.Bounds )), vrtCol, vrtCol, aBlend );

    for ( x = ( _this->CoordOrigin.X + dx ) + _this->GridDistance.X; x < ( dx + 
         EwGetRectW( _this->Super2.Bounds )); x = x + _this->GridDistance.X )
      GraphicsCanvas_DrawLine( aCanvas, aClip, EwNewPoint( x, dy ), EwNewPoint( 
      x, dy + EwGetRectH( _this->Super2.Bounds )), vrtCol, vrtCol, aBlend );
  }

  if ( _this->Coordinates == 0 )
    return;

  coord = _this->Coordinates->firstCoord;

  if ( coord != 0 )
  {
    p1X = (XFloat)( dx + _this->CoordOrigin.X ) + ( coord->X * (XFloat)_this->PixelPerUnit.X 
    );
    p1Y = (XFloat)( dy + _this->CoordOrigin.Y ) + ( coord->Y * (XFloat)_this->PixelPerUnit.Y 
    );
    coord = coord->next;
  }

  volatile unsigned long durations[100];
  volatile unsigned long lengths[100];
  volatile int durationsIndex = 0;
  static volatile long timesInLoopCounter = 0;
  static volatile long hadLongDurationCounter1 = 0;
  static volatile long hadLongDurationCounter2 = 0;

  int incrementedLongDurationCounter1 = 0;
  int incrementedLongDurationCounter2 = 0;


  for (durationsIndex=0; durationsIndex<100; durationsIndex++)
  {
	durations[durationsIndex] = 0;
	lengths[durationsIndex] = 0;
  }

  durationsIndex = 0;
  timesInLoopCounter++;
  unsigned long start = HAL_GetTick();

  while ( coord != 0 )
  {
    XFloat dirX;
    XFloat dirY;
    XFloat len;
    p2X = (XFloat)( dx + _this->CoordOrigin.X ) + ( coord->X * (XFloat)_this->PixelPerUnit.X 
    );
    p2Y = (XFloat)( dy + _this->CoordOrigin.Y ) + ( coord->Y * (XFloat)_this->PixelPerUnit.Y 
    );
    dirX = p2X - p1X;
    dirY = p2Y - p1Y;
    len = EwMathSqrt(( dirX * dirX ) + ( dirY * dirY ));

    if ( len != 0.000000f )
    {
      dirX = dirX / len;
      dirY = dirY / len;
    }

    if ( _this->LineBitmap != 0 )
      GraphicsCanvas_WarpBitmap( aCanvas, aClip, _this->LineBitmap, 0, p1X - ( dirY 
      * lw ), p1Y + ( dirX * lw ), 1.000000f, p1X + ( dirY * lw ), p1Y - ( dirX 
      * lw ), 1.000000f, p2X + ( dirY * lw ), p2Y - ( dirX * lw ), 1.000000f, p2X 
      - ( dirY * lw ), p2Y + ( dirX * lw ), 1.000000f, EwNewRect( 0, 0, _this->LineBitmap->FrameSize.X, 
      _this->LineBitmap->FrameSize.Y ), linCol, linCol, linCol, linCol, aBlend, 
      1 );

    if (durationsIndex < 100)
       {
       	durations[durationsIndex] = HAL_GetTick() - start;
       	if (durationsIndex > 0)
       	{
       		unsigned long delta = durations[durationsIndex] - durations[durationsIndex-1];

   			if (delta > 3)
   			{
   			  if (durationsIndex > 0 && !incrementedLongDurationCounter1)
   			  {
   				  hadLongDurationCounter1++;
   				  incrementedLongDurationCounter1 = 1;
   			  }
   			}
       	}
       	durationsIndex++;
       }

    if (( _this->DotWidth > 0.000000f ) && ( _this->DotBitmap != 0 ))
    {
      GraphicsCanvas_WarpBitmap( aCanvas, aClip, _this->DotBitmap, _this->DotBitmapIndex, 
      p1X - dw, p1Y - dw, 1.000000f, p1X + dw, p1Y - dw, 1.000000f, p1X + dw, p1Y 
      + dw, 1.000000f, p1X - dw, p1Y + dw, 1.000000f, EwNewRect( 0, 0, _this->DotBitmap->FrameSize.X, 
      _this->DotBitmap->FrameSize.Y ), dotCol, dotCol, dotCol, dotCol, aBlend, 1 
      );
    }

    if (durationsIndex < 100)
    {
    	durations[durationsIndex] = HAL_GetTick() - start;
    	if (durationsIndex > 0)
    	{
    		unsigned long delta = durations[durationsIndex] - durations[durationsIndex-1];

			if (delta > 3)
			{
			  if (durationsIndex > 0 && !incrementedLongDurationCounter2)
			  {
				  hadLongDurationCounter2++;
				  incrementedLongDurationCounter2 = 1;
			  }
			}
    	}
    	durationsIndex++;
    }

    p1X = p2X;
    p1Y = p2Y;
    coord = coord->next;
  }

  if (( _this->DotWidth > 0.000000f ) && ( _this->DotBitmap != 0 ))
  {
    GraphicsCanvas_WarpBitmap( aCanvas, aClip, _this->DotBitmap, _this->DotBitmapIndex, 
    p1X - dw, p1Y - dw, 1.000000f, p1X + dw, p1Y - dw, 1.000000f, p1X + dw, p1Y 
    + dw, 1.000000f, p1X - dw, p1Y + dw, 1.000000f, EwNewRect( 0, 0, _this->DotBitmap->FrameSize.X, 
    _this->DotBitmap->FrameSize.Y ), _this->DotColor, _this->DotColor, _this->DotColor, 
    _this->DotColor, aBlend, 1 );
  }
}

